#!/usr/bin/python

from piscript.PiModule import *
from piscript.Bernstein import *
# Bernstein defines a function bernstein(y, t)
# where y = [ y0, y1, y2, ... , yn ]
# defining a Bernstein polynomial of degree n

init("bernstein", 200, 200)

beginpage()
gsave()
center()
N = 32
t = 0
dt = 1.0/N
y = [0, 0, 0, 1, 1, 1]
scale(100)
translate(-0.5, -0.5)
newpath()
moveto(t, bernstein(y, t))
for i in range(N):
	t += dt
	lineto(t, bernstein(y, t))
stroke()
grestore()
translate(10, 10)
place(texinsert("$$B(t) = \sum_{0}^{6} b_{i} { 6 \choose i } (1-t)^{n-i}t^{i}$$"))
endpage()
flush()




