#!/usr/bin/python

from DviReader import *
from Tex import *
from PiScript import PiScript
from PSExec import PSExec
from PiScript3d import *
from Arc import *
# from Path import *
from Canvas import *
atan = math.atan

pi = math.pi
cos = math.cos
sin = math.sin
exp = math.exp
sqrt = math.sqrt
log = math.log
tan = math.tan
atan = math.atan
atan2 = math.atan2
acos = math.acos
asin = math.asin

# --- setup --------------------------------------------------------

def init(*args):
	global ps
	ps = PiScript(PSExec(), *args)
	return(ps)

def width():
	global ps
	return ps.width

def height():
	global ps
	return ps.height

def center():
	global ps
	ps.center()

def beginpage(*args):
	global ps
	ps.beginpage(*args)

def endpage():
	global ps
	ps.endpage()

# ---------------------------------------

def minx():
	global ps
	return ps.minx()

def maxx():
	global ps
	return ps.minx()

def miny():
	global ps
	return ps.minx()

def maxy():
	global ps
	return ps.minx()

# OBS.
def setbbox(bbox):
	global ps
	ps.setbbox(bbox)

# returns a parallelogram
def currentbbox():
	global ps
	return ps.currentbbox()

def currentcenter():
	global ps
	B = ps.currentbbox()
	return [ (B[0][0]+B[2][0])/2.0, (B[0][1]+B[2][1])/2.0]


# --- graphics state ------------------------------------------------

def gsave():
	global ps
	ps.gsave()

def grestore():
	global ps
	ps.grestore()

def cgs():
	global ps
	return ps.cgs()

def revert():
	global ps
	return ps.revert()

def lrevert():
	global ps
	return ps.lrevert()

def scale(*args):
	global ps
	ps.scale(*args)

def translate(*args):
	global ps
	ps.translate(*args)

def rotate(*args):
	global ps
	ps.rotate(*args)

def ltransform(*args):
	global ps
	ps.ltransform(*args)

def atransform(*args):
	global ps
	ps.atransform(*args)

def transform(*args):
	global ps
	ps.atransform(*args)

def affine_reflect(f):
	global ps
	ps.reflect(f)

def reflect(f):
	global ps
	ps.reflect(f)

def linethrough(P, Q):
	return VectorUtils.linethrough(P, Q)

def interpolation(p, q, t):
	return VectorUtils.interpolated(p, q, t)

def currentlinewidth():
	global ps
	return ps.currentlinewidth()
	
def scalelinewidth(c):
	global ps
	ps.scalelinewidth(c)

def setlinewidth(c):
	global ps
	ps.setlinewidth(c)

def setcolor(*args):
	global ps
	ps.setcolor(*args)

def setgray(g):
	global ps
	ps.setcolor(g)

def setlinecap(n):
	global ps
	ps.setlinecap(n)

def currentlinecap():
	global ps
	return ps.currentlinecap()
	
def setmiterlimit(x):
	global ps
	ps.setmiterlimit(x)
	
def setlinejoin(n):
	global ps
	ps.setlinejoin(n)

# pattern = a, offset = b
def setdash(a, offset=0):
	global ps
	ps.setdash(a, offset)

def setdeg():
	global ps
	ps.setdeg()

def setrad():
	global ps
	ps.setrad()

def todeg(x):
	global ps
	return ps.todeg(x)

def torad(x):
	global ps
	return ps.torad(x)

def zoom(x, c, s):
	translate(c)
	scale(s)
	translate(-x[0],-x[1])

# --- drawing ------------------------------------------------------

def newpath():
	global ps
	ps.newpath()

def moveto(*args):
	global ps
	ps.moveto(*args)

def connectto(*args):
	global ps
	ps.connectto(*args)

def lineto(*args):
	global ps
	ps.lineto(*args)

def quadto(*args):
	global ps
	ps.quadto(*args)

def curveto(*args):
	global ps
	ps.curveto(*args)

def rcurveto(*args):
	global ps
	ps.rcurveto(*args)

def rmoveto(*args):
	global ps
	ps.rmoveto(*args)

def rlineto(*args):
	global ps
	ps.rlineto(*args)

def current_point():
	global ps
	return ps.currentpoint()

def currentpoint():
	global ps
	return ps.currentpoint()

# --- shapes --------------------------------

def arc(*args):
	global ps
	ps.arc(*args)

def arcn(*args):
	global ps
	ps.arcn(*args)

def circle(*args):
	global ps
	ps.circle(*args)

def arcto(*args):
	global ps
	return ps.arcto(*args)

def box(*args):
	global ps
	ps.box(*args)

def polygon(*args):
	global ps
	ps.polygon(*args)

def parallelogram(*args):
	global ps
	ps.parallelogram(*args)

def bbox(*args):
	global ps
	ps.boundedbox(*args)

def boundedbox(*args):
	global ps
	ps.boundedbox(*args)

def graph(*args):
	global ps
	ps.graph(*args)

def grid(N, ds):
	ps.grid(N, ds)

# --- end of shapes ----------------------------------------

def stroke(*args):
	global ps
	ps.stroke(*args)

def fill(*args):
	global ps
	ps.fill(*args)

def clip():
	global ps
	ps.clip()

def closepath():
	global ps
	ps.closepath()

# (x, y, sw, hw, A, B)
# (x, y, sw, hw)
# (x, y)
# (r, sw, hw, A, B)
# (r, sw, hw)
# (r)

"""
def arrowto(*args):
	global ps
	Arrows.arrowto(ps, *args)

def openarrowto(*args):
	global ps
	Arrows.openarrowto(ps, *args)
"""

def arrow(*args):
	global ps
	ps.arrow(*args)

def openarrow(*args):
	global ps
	ps.openarrow(*args)

def quadarrow(*args):
	global ps
	ps.quadarrow(*args)

def setarrowdims(*args):
	global ps
	ps.setarrowdims(*args)

def texarrow(*args):
	global ps
	ps.texarrow(*args)

def arcarrow(*args):
	global ps
	ps.arcarrow(*args)

def arcnarrow(*args):
	global ps
	ps.arcnarrow(*args)

def ArcArrow(c, r, a, b):
	ps.arcarrow(c, r, a, b)

def ArcnArrow(c, r, a, b):
	ps.arcnarrow(c, r, a, b)

def arrowhead(A):
	ps.arrowhead(A)

def arrowheadlength():
	return ps.arrowheadlength()

# --- shfill ----------------------------------------------

from ShadedPath import ShadedPath

def shadedpath(wd):
	return ShadedPath(ps, wd)

from ShadedBand import ShadedBand

def shadedband():
	return ShadedBand(ps)

def shfill(ds):
	ps.shfill(ds)

# --- text -------------------------------------------------

def setfont(f, s):
	global ps
	ps.setfont(f, s)

# obsolescent 
def shift(f, s):
	global ps
	ps.shift(f, s)

def show(s, *args):
	global ps
	ps.show(s, *args)

def charpath(s, *args):
	global ps
	return ps.charpath(s, *args)

# =============================================================

from Tex import *


def settexprefix(s):
	global ps
	ps.settexprefix(s)

def settexmacros(s):
	global ps
	ps.settexprefix(s)

def settexpostfix(s):
	global ps
	ps.settexpostfix(s)

def settexcommand(s):
	global ps
	ps.settexcommand(s)

def settexsave(s):
	global ps
	ps.settexsave(s)

""" very complicated method:
	"plain"
	"latex"
	None
	file name: 
		if local, use it
		if not, look globally in piscript directory
			PlainTexConfig
			LatexTexConfig
			PSTexConfig
			BoldMathTexConfig
THe last two require 
	psfont.defs, boldmathfont.defs to be in the current directory
"""

def settexenv(*args):
	global ps
	ps.settexenv(*args)

# texcfg = (say) "plain" or "PlainTexConfig" or "latex"
# to revert to default, argument = None
# same arguments as settexenv
def settexconfig(texcfg):
	ps.settexconfig(texcfg)

# this returns a TexInsert structure, but does not place the TeX anywhere
def texinsert(texstring, save=None, pin=False):
	global ps
	return(ps.texinsert(texstring, save, pin))

def place(canvas, *args):
	global ps
	ps.place(canvas, *args)

def place3d(canvas, *args):
	global ps
	ps.place3d(canvas, *args)

def stringinsert(s):
	global ps
	return ps.stringinsert(s)

def canvas(*args):
	return Canvas(*args)

def insert(*args):
	return Canvas(*args)

def embed(*args):
	return ps.embed(*args)

def comment(s):
	ps.comment(s)

# --------------------------------------------------------------

# one user unit square = n x n pixels
"""
def image(*args):
	img = args[0]
	n = args[1]
	if len(args) == 2:
		interpolate = False
	else:
		interpolate = args[2]
	ps.put_image(img, n, interpolate)
"""

def image(img, n, interpolate = False):
	ps.put_image(img, n, interpolate)


# raw insertion:
def putPS(s):
	global ps
	ps.insert(s)

def include(s):
	global ps
	ps.include(s)

def importPS(f):
	global ps
	ps.importPS(f)

def importEPS(f):
	global ps
	ps.importEPS(f)

def epsboundingbox(epsfile):
	return PSExec.epsboundingbox(fn)

# legacy
def flush():
	global ps
	ps.finish()

def finish():
	global ps
	ps.finish()

# ======================================================================

# allow filename implicit?
def init3d(*args):
	global ps
	ps = PiScript3d(PSExec(), *args)
	return ps

def gsave3d():
	global ps
	ps.gsave3d()

def grestore3d():
	global ps
	ps.grestore3d()

def set_eye(e):
	global ps
	ps.set_eye(e)

def seteye(e):
	global ps
	ps.set_eye(e)

# returns virtual eye
def get_eye():
	global ps
	return(ps.get_eye())

def geteye():
	global ps
	return(ps.get_eye())

def set_light(L):
	global ps
	ps.set_light(L)

def setlight(L):
	global ps
	ps.set_light(L)

# returns virtual light
def get_light():
	global ps
	return ps.get_light()

# returns virtual light
def getlight():
	global ps
	return ps.get_light()

def project_to_2d(*args):
	global ps
	return ps.projectto2d(*args)

def projection2d(*args):
	global ps
	return ps.projectto2d(*args)

def scale3d(a,b,c):
	global ps
	ps.scale3d(a,b,c)

def gfxtransform3d(m):
	global ps
	ps.gfxtransform3d(m)

def rotate3d(a, A):
	global ps
	ps.rotate3d(a, A)

def translate3d(*args):
	global ps
	ps.translate3d(*args)

def project(f, P):
	global ps
	ps.project(f, P)

def moveto3d(*args):
	global ps
	ps.moveto3d(*args)

def rmoveto3d(*args):
	global ps
	ps.rmoveto3d(*args)

def lineto3d(*args):
	global ps
	ps.lineto3d(*args)

def rlineto3d(*args):
	global ps
	ps.rlineto3d(*args)

def curveto3d(P1,P2,P3):
	global ps
	ps.curveto3d(P1,P2,P3)

def closepath3d():
	global ps
	ps.closepath3d()

# --------------------------------------

def convexsurface(*args):
	return(ConvexSurface(*args))

def paint(s, *args):
	s.paint(ps, *args)

def outline(s, *args):
	s.outline(ps, *args)

def face(p, c):
	f = Face(p, c)
	return(f)

def reverse(f):
	return(f.reversed())

def setshading(f, y):
	f.setshading(y)

# f = array of triangular faces with third item = array of normals for the vertices
def smooth_convex_surface(f):
	return SmoothConvexSurface(f)

def smoothconvexsurface(f):
	return SmoothConvexSurface(f)

from Sphere import Sphere

def sphere(c, n):
	return Sphere(c, n)


# =======================================================================
# === Obsolescent =======================================================
# =======================================================================


from Type1 import *

# FIXME (DM 07/09/09): Update to use cache?
def font(fn):
	return(Type1Font(fn))

def draw(path):
	global ps
	ps.draw(path)

def currentwidth():
	global ps
	return ps.width

def currentheight():
	global ps
	return ps.height

def boundary(*args):
	global ps
	return ps.boundary(*args)

def envelope(a, b):
	global ps
	return ps.envelope(a, b)

def transform(m, v):
		return PSMatrix.transform(m, v)

# Canvas, P
def location(*args):
	global ps
	return ps.location(*args)

def eol():
	global ps
	ps.eol()

def importPFB(f):
	global ps
	ps.importPFB(f)

def set_shading(f, y):
	f.setshading(y)

def convex_surface(f):
	return(
			C + Vector(R*cos(A), 0, R*sin(A)),face(f))

# ============================================================================
# === Vectors ================================================================
# ============================================================================

from Vectors import Vector
import vector

# ============================================================================
# === Fonts ==================================================================
# ============================================================================

from TexFontNameDict import *
from TexAliasDict import *

def dimensions(s):
	global ps
	return ps.dimensions(s)

def fontlist():
	FL = []
	for k in aliasdict.keys():
		FL.append([k, aliasdict[k]])
	for k in texfontname.keys():
		FL.append([k, texfontname[k]])
	return FL

def append(path):
	global ps
	ps.append(path)


	


